﻿var ej = {};

function ejShowRes(res) {
	var html='', cl='', tmpTitle='', ok=true, tmpCss='';
	if (res<0) {
		cl = ' danger';
		tmpTitle = 'A negative value means that the current mix is not feasible.';
		tmpCss = ' style="cursor:help;"';
		ok=false;
	}
	if (ej.sh.ml) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res,2)+'</td>'; }
	if (ej.sh.cl) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res/10,2)+'</td>'; }
	if (ej.sh.dl) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res/100,2)+'</td>'; }
	if (ej.sh.l) { html += '<td class="text-right'+cl+'" title="'+tmpTitle+'"'+tmpCss+'>'+round(res/1000,2)+'</td>'; }
	return { html: html, ok: ok };
}

function calculateJuice() {
	//if (ej.nicUnit==='m') {
	//	ej.nicBaseNicP/=10;
	//}
	ej.nicBaseNonnicP = 100-ej.nicBaseNicP;
	ej.nicBaseRealVgP = ej.nicBaseVgP * (ej.nicBaseNonnicP/100);
	ej.nicBaseRealPgP = ej.nicBasePgP * (ej.nicBaseNonnicP/100);
	//if (ej.nicUnit==='m') {
	//	ej.targetNicP/=10;
	//}
	ej.nicTargetVol = ej.batch*ej.targetNicP/100;
	ej.nicBaseVol = ej.nicTargetVol/(ej.nicBaseNicP/100);
	ej.nicBaseNicVol = (ej.targetNicP/100)*ej.batch;
	ej.nicBasePgVol = ej.nicBaseVol * (ej.nicBaseRealPgP/100);
	ej.nicBaseVgVol = ej.nicBaseVol * (ej.nicBaseRealVgP/100);
	ej.targetPgVol = (ej.targetPgP/100)*(ej.batch-ej.nicBaseNicVol);
	ej.targetVgVol = (ej.targetVgP/100)*(ej.batch-ej.nicBaseNicVol);
	ej.addPgVol = ej.targetPgVol - ej.nicBasePgVol;
	ej.addVgVol = ej.targetVgVol - ej.nicBaseVgVol;
	var html;
	var tmp, tmpOk = true;
	html = '';
	html += '<thead>';
		html += '<tr>';
			html += '<th>Ingredient</th>';
			html += '<th class="text-right">'+ej.batchUnit+'</th>';
		html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
		html += '<tr>';
			html += '<td>Nicotine</td>';
			tmp = ejShowRes(round(ej.nicBaseNicVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>VG</td>';
			tmp = ejShowRes(round(ej.nicBaseVgVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
			html += '<td>PG</td>';
			tmp = ejShowRes(round(ej.nicBasePgVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
	html += '</tbody>';
	$('#ej-breakdown').html(html);
	html = '';
	html += '<thead>';
		html += '<tr>';
			html += '<th>Ingredient</th>';
			html += '<th class="text-right">'+ej.batchUnit+'</th>';
		html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
		html += '<tr>';
			html += '<td>Nicotine</td>';
			tmp = ejShowRes(round(ej.nicBaseNicVol,2));
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>VG</td>';
			tmp = ejShowRes(ej.targetVgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>PG</td>';
			tmp = ejShowRes(ej.targetPgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
	html += '</tbody>';
	$('#ej-ingredients').html(html);

	html = '';
	html += '<thead>';
		html += '<tr>';
			html += '<th>Add</th>';
			html += '<th class="text-right">'+ej.batchUnit+'</th>';
		html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
		html += '<tr>';
			html += '<td>Nicotine base</td>';
			tmp = ejShowRes(ej.nicBaseVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>VG</td>';
			tmp = ejShowRes(ej.addVgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
		html += '<tr>';
			html += '<td>PG</td>';
			tmp = ejShowRes(ej.addPgVol);
			html += tmp.html;
			if (!tmp.ok) { tmpOk = false; }
		html += '</tr>';
	html += '</tbody>';
	$('#ej-results').html(html);
	activateBlinkies($('#ej-results'));
	var errorMsg = '';
	if (ej.nicBaseNicP<ej.targetNicP) {
		errorMsg += '<p>Oops. Your target nicotine level is higher than your nicotine base strength. You should either get a stronger nic base liquid, or lower your target nic strength.</p>';
		tmpOk = false;
	}
	//console.log(tmpOk);
	var $em = $('#ej-errormsg');
	if (!tmpOk) {
		errorMsg += '<p>This mix is not feasible. You may need to lower your target nic, VG or PG content, use a stronger nic base liquid, or a nic base liquid with a different VG/PG ratio. Please adjust your settings.</p>';
		$em.html('<div class="alert alert-danger blinky" data-blink="#ej-results td.danger">' + errorMsg + '</div>');
		if (!$em.is(':visible')) {
			$em.slideDown(200);
		}
	} else {
		if ($em.is(':visible')) {
			$em.slideUp(200);
		}
	}
	return;
}


function defaultJuice() {
	return {
		batch : 10
		,sh : { 
			ml: true
			,cl: false
			,dl: false
			,l: false
			}
		,batchUnit : 'ml'
		,nicUnit : 'p'
		,nicBaseNicP : 2.7
		,nicBasePgP : 100
		,nicBaseVgP : 0
		,targetNicP : 1.8
		,targetPgP : 70
		,targetVgP : 30
	};
}

function writeJuice() {
	$('#ej-batch').val(ej.batch);
	$('#ej-nicbasepgp').val(ej.nicBasePgP);
	$('#ej-nicbasevgp').val(ej.nicBaseVgP);
	$('#ej-targetpgp').val(ej.targetPgP);
	$('#ej-targetvgp').val(ej.targetVgP);
	$('#ej-batch-u').find('input').prop('checked',false);
	var tmp = '#ej-batch-u-' + ej.batchUnit;
	$(tmp).prop('checked',true);
	if (ej.nicUnit==='m') {
		$('#ej-nic-unit-disclaimer').show('slideDown');
		$('#ej-nic-unit-p').prop('checked',false);
		$('#ej-nic-unit-mgml').prop('checked',true);
		$('.ej-nic-unit span').html('<sup>mg</sup>/<sub>ml</sub>');
		$('#ej-nicbasenicp').val(ej.nicBaseNicP*10);
		$('#ej-targetnicp').val(ej.targetNicP*10);
	} else {
		$('#ej-nic-unit-disclaimer').hide();
		$('#ej-nic-unit-mgml').prop('checked',false);
		$('#ej-nic-unit-p').prop('checked',true);
		$('.ej-nic-unit span').html('%');
		$('#ej-nicbasenicp').val(ej.nicBaseNicP);
		$('#ej-targetnicp').val(ej.targetNicP);
	}
	return;
}

function startJuice() {
	var tmp = seLoad('ej');
	if (tmp) {
		ej = tmp;
		writeJuice();
	} else {
		ej = defaultJuice();
		writeJuice();
		$('#ej-load').hide();
	}
	$('#ej-batch').change(function() {
		ej.batch = parseFloat($(this).val());
		calculateJuice();
		gad('juice', 'batch', ej.batch);
	});
	$('#ej-batch-unit').find('input').change(function() {
		ej.batchUnit = $(this).val();
		$('#ej-batch-addon span').html(ej.batchUnit);
		calculateJuice();
		gad('juice', 'batchunit', ej.batchUnit);
	});
	$('#ej-nic-unit').find('input').change(function() {
		if ($('#ej-nic-unit-p').is(':checked')) {
			ej.nicUnit = 'p';
			//$('#ej-nicbasenicp').val($('#ej-nicbasenicp').val()/10).attr('step','0.1').attr('max','50');
			//$('#ej-targetnicp').val($('#ej-targetnicp').val()/10).attr('step','0.1').attr('max','10');
			//ej.nicP
		} else {
			ej.nicUnit = 'm';
			//$('#ej-nicbasenicp').val($('#ej-nicbasenicp').val()*10).attr('step','1').attr('max','500');
			//$('#ej-targetnicp').val($('#ej-targetnicp').val()*10).attr('step','1').attr('max','100');
		}
		writeJuice();
		ej.nicBaseNicP = parseFloat($('#ej-nicbasenicp').val());
		if (ej.nicUnit === 'm') {
			ej.nicBaseNicP /= 10;
		}
		calculateJuice();
		gad('juice', 'nicunit', ej.nicUnit);
	});
	$('#ej-nicbasenicp').change(function() {
		ej.nicBaseNicP = parseFloat($(this).val());
		if (ej.nicUnit === 'm') {
			ej.nicBaseNicP /= 10;
		}
		calculateJuice();
		gad('juice', 'nicbasenicp', ej.nicBaseNicP);
	});
	$('#ej-nicbasepgp').change(function() {
		ej.nicBasePgP = parseFloat($(this).val());
		ej.nicBaseVgP = 100 - ej.nicBasePgP;
		$('#ej-nicbasevgp').val(ej.nicBaseVgP);
		calculateJuice();
		gad('juice', 'nicbasepgp', ej.nicBasePgP);
	});
	$('#ej-nicbasevgp').change(function() {
		ej.nicBaseVgP = parseFloat($(this).val());
		ej.nicBasePgP = 100 - ej.nicBaseVgP;
		$('#ej-nicbasepgp').val(ej.nicBasePgP);
		calculateJuice();
		gad('juice', 'nicbasevgp', ej.nicBaseVgP);
	});
	$('#ej-targetnicp').change(function() {
		ej.targetNicP = parseFloat($(this).val());
		if (ej.nicUnit === 'm') {
			ej.targetNicP /= 10;
		}
		calculateJuice();
		gad('juice', 'targetnicp', ej.targetNicP);
	});
	$('#ej-targetpgp').change(function() {
		ej.targetPgP = parseFloat($(this).val());
		ej.targetVgP = 100 - ej.targetPgP;
		$('#ej-targetvgp').val(ej.targetVgP);
		gad('juice', 'targptpgp', ej.targetPgP);
		calculateJuice();
	});
	$('#ej-targetvgp').change(function() {
		ej.targetVgP = parseFloat($(this).val());
		ej.targetPgP = 100 - ej.targetVgP;
		$('#ej-targetpgp').val(ej.targetPgP);
		gad('juice', 'targetvgp', ej.targetVgP);
		calculateJuice();
	});
	$('#ej-save').click(function() {
		seSave('ej',ej);
		$('#ej-load').show();
		gad('juice', 'save');
	});
	$('#ej-load').click(function() {
		tmp = seLoad('ej');
		ej = tmp;
		writeJuice();
		calculateJuice();
		gad('juice', 'load');
	});
	$('#ej-reset').click(function() {
		ej = defaultJuice();
		writeJuice();
		calculateJuice();
		ccMenuMsg('Default settings have been restored.','success');
		gad('juice', 'reset');
	});
	calculateJuice();
	return;
}

$(document).ready(function() {
	//$.getJSON('http://freegeoip.net/json/', function(location) {
		//choo.country = location.country_code;
		startJuice();
	//});
});