﻿var mr = {
	r : []
};

function dround(nr) {
	if (nr<1) {
		return round(nr,3);
	}
	if (nr<10) {
		return round(nr,2);
	}
	return round(nr,1);
}

function findMaxPower() {
	//var umin = parseFloat($('#umin').val());
	var umax = parseFloat($('#umax').val());
	//var pmin = parseFloat($('#pmin').val());
	var pmax = parseFloat($('#pmax').val());
	var rmin = parseFloat($('#rmin').val());
	var rmax = parseFloat($('#rmax').val());
	var imax = parseFloat($('#imax').val());
	var tmpU, tmpI, tmpR1, tmpR2;
	$('#res').find('.imax').html(imax);
	$('#res').find('.umax').html(umax);
	$('#res').find('.pmax').html(pmax);
	$('#res').find('.rmin').html(rmin);
	$('#res').find('.rmax').html(rmax);
	// Voltage limit
	tmpU = pmax/imax;
	$('#res1').find('.ures').html(dround(tmpU));
	if (tmpU>umax) {
		$('#res1 .maxu').show();
		tmpU = umax;
	} else {
		$('#res1 .maxu').hide();
	}
	tmpR1 = tmpU/imax;
	$('#res1').find('.rres').html(dround(tmpR1));
	if (tmpR1<rmin) {
		$('#res1 .minr').show();
		$('#res1 .maxr').hide();
		tmpR1 = rmin;
	} else if (tmpR1>rmax) {
		$('#res1 .minr').hide();
		$('#res1 .maxr').show();
		tmpR1 = rmax;
	} else {
		$('#res1 .minr').hide();
		$('#res1 .maxr').hide();
	}
	$('#res3').find('.rmin').html(dround(tmpR1));
	// Current limit
	tmpI = pmax/umax;
	$('#res2').find('.ires').html(dround(tmpI));
	if (tmpI>imax) {
		tmpI = imax;
		$('#res2 .maxi').show();
	} else {
		$('#res2 .maxi').hide();
	}
	tmpR2 = umax/tmpI;
	$('#res2').find('.rres').html(dround(tmpR2));
	if (tmpR2<rmin) {
		$('#res2 .minr').show();
		$('#res2 .maxr').hide();
		tmpR2 = rmin;
	} else if (tmpR2>rmax) {
		$('#res2 .minr').hide();
		$('#res2 .maxr').show();
		tmpR2 = rmax;
	} else {
		$('#res2 .minr').hide();
		$('#res2 .maxr').hide();
	}
	$('#res3').find('.rmax').html(dround(tmpR2));
	
	// middle spot?
	var middle = umax / imax;
	var limitedmiddle;
	//console.log(middle);
	if (middle < rmin) {
		$('#res3 .rmid').html('<s title="Median resistance is below ohm limit." class="text-muted helpcursor">' + dround(middle) + '</s> ' + dround(rmin));
		limitedmiddle = rmin;
	} else if (middle > rmax) {
		$('#res3 .rmid').html('<s title="Median resistance is above ohm limit." class="text-muted helpcursor">' + dround(middle) + '</s> ' + dround(rmax));
		limitedmiddle = rmax;
	} else {
		$('#res3 .rmid').html(dround(middle));
		limitedmiddle = middle;
	}
	
	// en gang
	var sweet1 = (tmpR2 + limitedmiddle)/2;
	$('#res3 .rsweet').html(dround(sweet1));
	var html = '';
	if (tmpR1===tmpR2) {
		html += 'No resistance range? Try decreasing the max power.';
		$('#res3 .panel-footer').show();
	} else {
		$('#res3 .panel-footer').hide();
	}
	$('#res3 .panel-footer .help-block').html(html);
	
	return;
}

$(document).ready(function() {
	$('input').change(function() {
		findMaxPower();
	});
	$('#modpreset').change(function() {
		var $sel = $(this);
		var $opt = $sel.find(':selected');
		if ($opt.html()==='') {
			return;
		}
		var tmpChip = $opt.attr('data-chip');
		if (tmpChip !== undefined) {
			$opt = $sel.find('option[data-nm="'+tmpChip+'"]');
		}
		if ($opt.val()==='unknown') {
			feedbackModal(
				'Suggest APV preset'
				,'<p>If you don\'t find your mod among the presets, you can <strong>manually enter the stats</strong> in the calculator.</p><p>If you also want your VV/VW mod to be listed in the presets some time in the future, you can suggest it here. Please fill out all the specifications.</p><p><strong>Incomplete submissions will be deleted.</strong> Without all the required specs, it is not possible to calculate anything useful.</p>'
				,'Manufacturer (REQUIRED): \nModel name (REQUIRED): \nMax voltage (REQUIRED): \nMax power (REQUIRED): \nMax current (REQUIRED): \nMin/max resistance (optional): \nMin voltage (optional): \nMin power (optional): '
			);
			$('.modal-body textarea').css('height','10em');
			return;
		}
		var umin = $opt.attr('data-umin');
		if (umin===undefined) { umin = 0; } else { umin = parseFloat(umin); }
		//$('#umin').val(dround(umin));
		
		var umax = $opt.attr('data-umax');
		if (umax===undefined) { umax = 999; } else { umax = parseFloat(umax); }
		$('#umax').val(dround(umax));
		
		var pmin = $opt.attr('data-pmin');
		if (pmin===undefined) { pmin = 0; } else { pmin = parseFloat(pmin); }
		//$('#pmin').val(dround(pmin));
		
		var pmax = $opt.attr('data-pmax');
		if (pmax===undefined) { pmax = 999; } else { pmax = parseFloat(pmax); }
		$('#pmax').val(dround(pmax));

		var imax = $opt.attr('data-imax');
		if (imax===undefined) { imax = 999; } else { imax = parseFloat(imax); }
		$('#imax').val(dround(imax));

		var rmin = $opt.attr('data-rmin');
		if (rmin===undefined  || isNaN(rmin)  || rmin === 'NaN'  || rmin === '') {
			rmin = 0.01;
			$('#rmin').val('');
		} else {
			rmin = parseFloat(rmin);
			$('#rmin').val(dround(rmin));
		}
		var rmax = $opt.attr('data-rmax');
		//console.log(rmax, typeof(rmax), isNaN(rmax));
		if (rmax===undefined || isNaN(rmax) || rmax === 'NaN' || rmax === '') {
			rmax = 999;
			$('#rmax').val('');
		} else {
			rmax = parseFloat(rmax);
			$('#rmax').val(dround(rmax));
		}
		findMaxPower();
		gad('modrange', 'preset', $opt.html().replace(/ /g, '_'));
	});
	$('#modpreset option.syn').each(function() {
		var tmpChip = $(this).attr('data-chip');
		if (tmpChip !== undefined) {
			var $opt = $('#modpreset').find('option[data-nm="'+tmpChip+'"]');
			$(this).html($(this).html() + ' (' + $opt.html() + ')');
		}
	});
	$('#hidesyns').click(function() {
		if ($(this).is(':checked')) {
			$('#modpreset option.syn').hide();
		} else {
			$('#modpreset option.syn').show();
		}
	});
	findMaxPower();
});